Subject: [port-srv-reg] explanatory text on http://www.iana.org/assignments/port-numbers

From: Lars Eggert <[email-masked]>
Date: Thu, 14 Jan 2010 13:52:37 +0200

Hi,

I've recently had reason to look at the explanatory text (i.e., the bits that aren't port listings) on http://www.iana.org/assignments/port-numbers.

Either I'm misunderstanding things badly, or the text is out of date and out of sync with how we handle things. It also has some other oddities.

Here is the entire text (minus the actual listings). Comments and questions inline:

> PORT NUMBERS
> 
> (last updated 2010-01-11)
> 
> The port numbers are divided into three ranges: the Well Known Ports,
> the Registered Ports, and the Dynamic and/or Private Ports.
> 
> The Well Known Ports are those from 0 through 1023.
> 
> DCCP Well Known ports SHOULD NOT be used without IANA registration.
> The registration procedure is defined in [RFC4340], Section 19.9.

This SHOULD NOT is not specific to DCCP. But the text in RFC4340 is not super clear. I actually believe it means to say "you SHOULD NOT use port numbers already allocated for TCP or UDP for DCCP without registering this use with IANA first."

In any event, it is a bit odd to see this test here and nothing about TCP/UDP/SCTP.

> The Registered Ports are those from 1024 through 49151
> 
> DCCP Registered ports SHOULD NOT be used without IANA registration.
> The registration procedure is defined in [RFC4340], Section 19.9.

Same comment as above.

> The Dynamic and/or Private Ports are those from 49152 through 65535
> 
> A value of 0 in the port numbers registry below indicates that no port 
> has been allocated.

The only instance I can find is spr-itunes. I guess this will turn into a service name registration after draft-ietf-tsvwg-iana-ports is done?

> ************************************************************************
> * PLEASE NOTE THE FOLLOWING:                                           *
> *                                                                      *
> * IESG STATEMENT TO THE IANA                                           *
> *    THE IESG BELIEVES THAT IANA MAY ALLOCATE AN ADDITIONAL PORT IN    *
> *    THE 'USER PORT' RANGE TO PROTOCOLS WHOSE CURRENT PORT ALLOCATION  *
> *    REQUIRES ACCESS TO A PRIVILEGED PORT. THIS ALLOCATION SHOULD NOT  *
> *    BE AUTOMATIC, BUT MAY OCCUR UPON APPLICATION BY AN INTERESTED     *
> *    PARTY WHOSE APPLICATION WOULD OTHERWISE FIT IANA'S POLICIES.      *

This should probably be merged into draft-ietf-tsvwg-iana-ports, or the document that explains the procedure of the ports-review team.

> * 1. UNASSIGNED PORT NUMBERS SHOULD NOT BE USED.  THE IANA WILL ASSIGN *
> * THE NUMBER FOR THE PORT AFTER YOUR APPLICATION HAS BEEN APPROVED.    *

Does this only apply to the Well Known range, or also to the Registered Range? Because it conflicts with text in the description of the Registered range (see below.)

> * 2. ASSIGNMENT OF A PORT NUMBER DOES NOT IN ANY WAY IMPLY AN          *
> * ENDORSEMENT OF AN APPLICATION OR PRODUCT, AND THE FACT THAT NETWORK  *
> * TRAFFIC IS FLOWING TO OR FROM A REGISTERED PORT DOES NOT MEAN THAT   *
> * IT IS "GOOD" TRAFFIC. FIREWALL AND SYSTEM ADMINISTRATORS SHOULD      *
> * CHOOSE HOW TO CONFIGURE THEIR SYSTEMS BASED ON THEIR KNOWLEDGE OF    *
> * THE TRAFFIC IN QUESTION, NOT WHETHER THERE IS A PORT NUMBER          *
> * REGISTERED OR NOT.                                                   *
> ************************************************************************
> 
> 
> WELL KNOWN PORT NUMBERS
> 
> The Well Known Ports are assigned by the IANA and on most systems can
> only be used by system (or root) processes or by programs executed by
> privileged users.
> 
> Ports are used in the TCP [RFC793] to name the ends of logical
> connections which carry long term conversations.  For the purpose of
> providing services to unknown callers, a service contact port is
> defined.  This list specifies the port used by the server process as
> its contact port.  The contact port is sometimes called the
> "well-known port".
> 
> To the extent possible, these same port assignments are used with the
> UDP [RFC768].

This intro needs to be rephrased for SCTP and DCCP. The bit about calling the contact port the well known port is confusing, because contacts ports can obviously also be registered ports.

> The range for well-known ports managed by the IANA is 0-1023.
> 
> Port Assignments:
> 
> Keyword         Decimal    Description                     References
> -------         -------    -----------                     ----------
> ...
> 
> 
> REGISTERED PORT NUMBERS
> 
> The Registered Ports are listed by the IANA and on most systems can be
> used by ordinary user processes or programs executed by ordinary
> users.
> 
> Ports are used in the TCP [RFC793] to name the ends of logical
> connections which carry long term conversations.  For the purpose of
> providing services to unknown callers, a service contact port is
> defined.  This list specifies the port used by the server process as
> its contact port.
> 
> The IANA registers uses of these ports as a convenience to the
> community.

This is the statement I have the most issues with. So if this a "convenience" to the community, we should not even be reviewing these requests. If this is true, anyone can just take numbers out of this range.

My interpretation is that this might have been the case when this text was written, but that these days IANA treats the Well Known and Registered ranges the same, except for a higher review bar for Well Known registrations. We need to correct this if this is true.

> To the extent possible, these same port assignments are used with the
> UDP [RFC768].
> 
> The Registered Ports are in the range 1024-49151.

This doesn't say "managed by IANA" like the equivalent text for the Well Known range does. Oversight or deliberate? Does IANA believe they have management rights for the Registered range? (I believe you do.)

> Port Assignments:
> 
> Keyword         Decimal    Description                     References
> -------         -------    -----------                     ----------
> ...
> 
> 
> DYNAMIC AND/OR PRIVATE PORTS
> 
> The Dynamic and/or Private Ports are those from 49152 through 65535

Lars

---

From: Eliot Lear <[email-masked]>
Date: Thu, 14 Jan 2010 14:02:06 +0100

Hmm.  Lars, I agree that document is out of date.  Quite frankly I was
waiting for yours ;-)

Eliot

On 1/14/10 12:52 PM, Lars Eggert wrote:
> _______________________________________________
> IANA-Port-Experts mailing list
> [email-masked]
> https://mm.icann.org/mailman/listinfo/iana-port-experts
>

---

From: Lars Eggert <[email-masked]>
Date: Thu, 14 Jan 2010 15:23:16 +0200

On 2010-1-14, at 15:02, Eliot Lear wrote:
> Hmm.  Lars, I agree that document is out of date.  Quite frankly I was waiting for yours ;-)

Understood. We got comments on ours saying "what you wrote here is not aligned with what's on the IANA page", and I'm trying to establish agreement that the IANA page is outdated...

Lars

---

From: Michelle Cotton <[email-masked]>
Date: Thu, 14 Jan 2010 10:43:58 -0800

Lars,

I remember the plan was to update the text in the registry when the document gets published.

Michelle

On 1/14/10 3:52 AM, "Lars Eggert" <[email-masked]> wrote:

Hi,

Same comment as above.

Lars

---

From: Lars Eggert <[email-masked]>
Date: Fri, 15 Jan 2010 10:44:15 +0200

Hi,

> I remember the plan was to update the text in the registry when the document gets published.

could you say a bit more about in which way it would be updated? Basically, I need to make sure that my understanding of what this page should say is correct or not, so I can tell the folks who say "but IANA has never managed ports over 1024 (and registered means something different from assigned)" that they are wrong.

Even better would be if you tell them they are wrong, as Ms. IANA :-)

Lars